summaryrefslogtreecommitdiffstats
path: root/libraries/c-blosc
diff options
context:
space:
mode:
author Lockywolf2023-07-15 05:36:19 +0200
committer Willy Sudiarto Raharjo2023-07-15 05:36:19 +0200
commitaa3ce12cedc5ac50c48ee9b630537532b94a90a5 (patch)
tree66184f0de177b3ba3a05a03b3e61797231a9ad37 /libraries/c-blosc
parent242b54ea1b17966fe535569db97ca6f449cf8f90 (diff)
downloadslackbuilds-aa3ce12cedc5ac50c48ee9b630537532b94a90a5.tar.gz
libraries/c-blosc: Added (high performance compressor).
Signed-off-by: Willy Sudiarto Raharjo <willysr@slackbuilds.org>
Diffstat (limited to 'libraries/c-blosc')
-rw-r--r--libraries/c-blosc/README14
-rw-r--r--libraries/c-blosc/c-blosc.SlackBuild112
-rw-r--r--libraries/c-blosc/c-blosc.info10
-rw-r--r--libraries/c-blosc/slack-desc19
4 files changed, 155 insertions, 0 deletions
diff --git a/libraries/c-blosc/README b/libraries/c-blosc/README
new file mode 100644
index 0000000000..0180de8665
--- /dev/null
+++ b/libraries/c-blosc/README
@@ -0,0 +1,14 @@
+Blosc is a high performance compressor optimized for binary data. It
+has been designed to transmit data to the processor cache faster than
+the traditional, non-compressed, direct memory fetch approach via a
+memcpy() OS call. Blosc is the first compressor (that I'm aware of)
+that is meant not only to reduce the size of large datasets on-disk or
+in-memory, but also to accelerate memory-bound computations.
+
+It uses the blocking technique so as to reduce activity in the memory
+bus as much as possible. In short, this technique works by dividing
+datasets in blocks that are small enough to fit in caches of modern
+processors and perform compression / decompression there. It also
+leverages, if available, SIMD instructions (SSE2, AVX2) and
+multi-threading capabilities of CPUs, in order to accelerate the
+compression / decompression process to a maximum.
diff --git a/libraries/c-blosc/c-blosc.SlackBuild b/libraries/c-blosc/c-blosc.SlackBuild
new file mode 100644
index 0000000000..053ec8aedb
--- /dev/null
+++ b/libraries/c-blosc/c-blosc.SlackBuild
@@ -0,0 +1,112 @@
+#!/bin/bash
+
+# Slackware build script for c-blosc
+
+# Copyright 2023, Lockywolf
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PRGNAM=c-blosc
+VERSION=${VERSION:-1.21.4}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+PKGTYPE=${PKGTYPE:-tgz}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
+ exit 0
+fi
+
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+elif [ "$ARCH" = "aarch64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/$PRGNAM-$VERSION.tar.gz
+cd $PRGNAM-$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+mkdir -p build
+cd build
+ cmake \
+ -DCMAKE_C_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_CXX_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_INSTALL_PREFIX=/usr \
+ -DLIB_SUFFIX=${LIBDIRSUFFIX} \
+ -DMAN_INSTALL_DIR=/usr/man \
+ -DBUILD_STATIC=OFF \
+ -DCMAKE_BUILD_TYPE=Release ..
+ make
+ make install/strip DESTDIR=$PKG
+cd ..
+
+rm -f $PKG/{,usr/}lib${LIBDIRSUFFIX}/*.la
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a \
+ THANKS.rst RELEASE_NOTES.rst README.md LICENSE.txt FAQ.md CONTRIBUTING.md ANNOUNCE.rst \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE
diff --git a/libraries/c-blosc/c-blosc.info b/libraries/c-blosc/c-blosc.info
new file mode 100644
index 0000000000..deb05b9266
--- /dev/null
+++ b/libraries/c-blosc/c-blosc.info
@@ -0,0 +1,10 @@
+PRGNAM="c-blosc"
+VERSION="1.21.4"
+HOMEPAGE="https://github.com/Blosc/c-blosc"
+DOWNLOAD="https://github.com/Blosc/c-blosc/archive/refs/tags/v1.21.4/c-blosc-1.21.4.tar.gz"
+MD5SUM="926a33912611073f671d9e442628e889"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES=""
+MAINTAINER="Lockywolf"
+EMAIL="for_sbo.blosc_2023-07-12@lockywolf.net"
diff --git a/libraries/c-blosc/slack-desc b/libraries/c-blosc/slack-desc
new file mode 100644
index 0000000000..e35479e209
--- /dev/null
+++ b/libraries/c-blosc/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+c-blosc: c-blosc (a high performance compressor optimized for binary data)
+c-blosc:
+c-blosc: It has been designed to transmit data to the processor cache faster
+c-blosc: than the traditional, non-compressed, direct memory fetch approach
+c-blosc: via a memcpy() OS call. Blosc is the first compressor that is meant
+c-blosc: not only to reduce the size of large datasets on-disk or in-memory,
+c-blosc: but also to accelerate memory-bound computations.
+c-blosc: It uses the blocking technique so as to reduce activity in the
+c-blosc: memory bus as much as possible. In short, this technique works by
+c-blosc: dividing datasets in blocks that are small enough to fit in caches.
+c-blosc: